
local scale = 1
local w = 500
local h = 1
local t = 0

local tx = {}

local region = "US"
local realm = ""
local faction = ""
local ctx = ""

local function RS_CreateTexture(w,h,l,t,r,g,b)
	local f = CreateFrame("frame")
	f:SetPoint("LEFT", l, 0)
	f:SetPoint("TOP", 0, -t)
	f:SetFrameStrata("High")
	f:SetFrameLevel(20)
	f:SetWidth(w)
	f:SetHeight(h)
	f:SetAlpha(1.0)
	f:SetPoint("CENTER", 0, 0)
	
	local t = f:CreateTexture("Texture", "Background")
	t:SetTexture(1, 1, 1, 1)
	t:SetWidth(w)
	t:SetHeight(h)
	t:SetBlendMode("Disable")
	t:SetDrawLayer("Artwork", 0)
	t:SetVertexColor(r, g, b, 1)
	t:SetAllPoints(f)
	
	f:Show()
	
	return t
end

local function RS_ClearData()
	local sz = w * h

	for i=0,sz do
		tx[i]:SetTexture(0,0,0,1)
		tx[i]:SetVertexColor(0,0,0,1)
	end
end

local function RS_WriteData(udata)
	RS_ClearData()

	local data = '::1:' .. region ..':' .. udata
	local len = string.len(data)
	
	local w2 = w * 2
	
	if len > w2 then
		len = w2
	end
	
	local mid = 0
	local txi = 0
	
	for x=1,len,w do
		local e = w + x - 1
		if e > len then 
			e = len
		end
		local sub = string.sub(data, x, e)
		local slen = string.len(sub)
		
		mid = 0
		
		for i=1,slen,2 do
			local r = string.byte(sub, i) / 255.0
			local g = 0
			
			if (i + 1 <= slen) then 
				g = string.byte(sub, i + 1) / 255.0
			else 
				g = 0
			end
			
			tx[txi]:SetTexture(1,1,1,1)
			tx[txi]:SetVertexColor(r,g,mid,1)
			
			mid = mid + (1.0 / 255.0)
			txi = txi + 1
		end
	end
end

local function RS_SlashData(msg,eb)
	RS_WriteData(msg)
end

local function RS_WriteCurrent()
	local nmembers = GetNumGroupMembers()
	local realmchars = { [realm] = {} }
	
	if nmembers == 0 then
		local name = UnitName("player");
		table.insert(realmchars[realm], name)
	else
		for i=0,nmembers do 
			local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
			
			if name == nil then
			else
				local i,j = strfind(name, "-")
				if i == nil then 
					table.insert(realmchars[realm], name)
				else
					local nname = string.sub(name, 1, i - 1)
					local nrealm = string.sub(name, i + 1)
					local ndict = realmchars[nrealm]
					if ndict == nil then
						ndict = {}
					end
					table.insert(ndict, nname)
					realmchars[nrealm] = ndict
				end
			end
		end
	end
	
	local d = ctx .. ':'
	
	for k,v in pairs(realmchars) do 
		local vd = ""
		
		for i=1,#v do
			vd = vd .. v[i] .. ","
		end
	
		d = d .. k .. "-" .. vd .. "|"
	end

	RS_WriteData(d)
end

function RS_OnEvent(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD" then
		factionGroup, factionLoc = UnitFactionGroup("player")
		faction = factionGroup
	
		local name, typ, diffIndex, diffName, maxPlayers, dynamicDiff, isDynamic, mapID = GetInstanceInfo()
		
		if typ == "raid" then
			ctx = "E:" .. name .. " (" .. diffName .. ")"
		elseif typ == "pvp" then
			ctx = "P:" .. name
		else
			ctx = "E:" .. name
		end
	end
	
	RS_WriteCurrent()
end

function RS_OnLoad(self)
	for j=0,h do
		for i=0,w do
			tx[j * w + i] = RS_CreateTexture(scale, scale, i * scale, t + j * scale, 0, 0, 0)
		end
	end
	
	local regID = GetCurrentRegion()
	if regID == 1 then
		region = "US"
	elseif regID == 2 then 
		region = "KR"
	elseif regID == 3 then
		region = "EU"
	elseif regID == 4 then
		region = "TW"
	elseif regID == 5 then
		region = "CN"
	else 
		region = "UN"
	end
	
	realm = GetRealmName()
	ctx = "E:Unknown"
	
	SLASH_NORGANNON1 = "/raidspy"
	SlashCmdList["NORGANNON"] = RS_SlashData
	
	self:RegisterEvent("GROUP_ROSTER_UPDATE", RS_OnEvent, true)
	self:RegisterEvent("PLAYER_ENTERING_WORLD", RS_OnEvent, true)
	
	RS_WriteCurrent()
end
